// catryView.cpp : implementation of the CCatryView class
//

#include "stdafx.h"
#include "catry.h"

#include "catryDoc.h"
#include "catryView.h"

#define RULESIZE 32769

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCatryView

IMPLEMENT_DYNCREATE(CCatryView, CView)

BEGIN_MESSAGE_MAP(CCatryView, CView)
	//{{AFX_MSG_MAP(CCatryView)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCatryView construction/destruction

CCatryView::CCatryView()
{
	// TODO: add construction code here

}

CCatryView::~CCatryView()
{
}

BOOL CCatryView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CCatryView drawing

void CCatryView::OnDraw(CDC* pDC)
{
	CCatryDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CCatryView diagnostics

#ifdef _DEBUG
void CCatryView::AssertValid() const
{
	CView::AssertValid();
}

void CCatryView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCatryDoc* CCatryView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCatryDoc)));
	return (CCatryDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCatryView message handlers

void SetRule(BYTE rules[], int c, int t, int r, int b, int l, int val)
{
	rules[l+8*b+64*r+512*t+4096*c]=val;
}

//Thread fn
UINT DotThread(LPVOID pParam)
{
	CCatryView *view=(CCatryView *) pParam;
	srand (GetTickCount());
	BYTE gridShow[256][256];
	BYTE gridComp[256][256];
	int i,j;
	BYTE rules[RULESIZE];
	char rd,gn,bl;
	int ctr=0;

	CClientDC dc(view);

	srand ((unsigned)time(NULL));
	#define RAND_MAX 100 
	
	//initialize to 0
	for (i=0;i<256;i++)
	{
		for (j=0;j<256;j++) 
		{
			//if (rand()%50==1)
			//	gridShow[i][j]=(BYTE)(rand()%8);
			//else
				gridShow[i][j]=0;
	//		//gridComp[i][j]=0;
		}
	}

	//build seed pattern
	gridShow[120][121]=2;
	gridShow[120][122]=2;
	gridShow[120][123]=2;
	gridShow[120][124]=2;
	gridShow[120][125]=2;
	gridShow[120][126]=2;
	gridShow[120][127]=2;
	gridShow[120][128]=2;
	
	gridShow[121][120]=2;
	gridShow[121][121]=1;
	gridShow[121][122]=0;
	gridShow[121][123]=7;
	gridShow[121][124]=1;
	gridShow[121][125]=0;
	gridShow[121][126]=7;
	gridShow[121][127]=1;
	gridShow[121][128]=0;
	gridShow[121][129]=2;

	gridShow[122][120]=2;
	gridShow[122][121]=7;
	gridShow[122][122]=2;
	gridShow[122][123]=2;
	gridShow[122][124]=2;
	gridShow[122][125]=2;
	gridShow[122][126]=2;
	gridShow[122][127]=2;
	gridShow[122][128]=7;
	gridShow[122][129]=2;

	gridShow[123][120]=2;
	gridShow[123][121]=0;
	gridShow[123][122]=2;
	gridShow[123][127]=2;
	gridShow[123][128]=1;
	gridShow[123][129]=2;

	gridShow[124][120]=2;
	gridShow[124][121]=1;
	gridShow[124][122]=2;
	gridShow[124][127]=2;
	gridShow[124][128]=0;
	gridShow[124][129]=2;

	gridShow[125][120]=2;
	gridShow[125][121]=4;
	gridShow[125][122]=2;
	gridShow[125][127]=2;
	gridShow[125][128]=7;
	gridShow[125][129]=2;

	gridShow[126][120]=2;
	gridShow[126][121]=0;
	gridShow[126][122]=2;
	gridShow[126][127]=2;
	gridShow[126][128]=1;
	gridShow[126][129]=2;

	gridShow[127][120]=2;
	gridShow[127][121]=1;
	gridShow[127][122]=2;
	gridShow[127][123]=2;
	gridShow[127][124]=2;
	gridShow[127][125]=2;
	gridShow[127][126]=2;
	gridShow[127][127]=2;
	gridShow[127][128]=0;
	gridShow[127][129]=2;

	gridShow[128][120]=2;
	gridShow[128][121]=4;
	gridShow[128][122]=0;
	gridShow[128][123]=1;
	gridShow[128][124]=1;
	gridShow[128][125]=1;
	gridShow[128][126]=1;
	gridShow[128][127]=1;
	gridShow[128][128]=7;
	gridShow[128][129]=2;

	gridShow[129][121]=2;
	gridShow[129][122]=2;
	gridShow[129][123]=2;
	gridShow[129][124]=2;
	gridShow[129][125]=2;
	gridShow[129][126]=2;
	gridShow[129][127]=2;
	gridShow[129][128]=1;
	gridShow[129][129]=2;

	gridShow[130][127]=2;
	gridShow[130][128]=1;
	gridShow[130][129]=2;

	gridShow[131][127]=2;
	gridShow[131][128]=1;
	gridShow[131][129]=2;

	gridShow[132][127]=2;
	gridShow[132][128]=1;
	gridShow[132][129]=2;

	gridShow[133][127]=2;
	gridShow[133][128]=1;
	gridShow[133][129]=2;

	gridShow[134][128]=2; 
 

	//set the rules for the CA array
	//but first, invalidate the non-specified ones
	for (ctr=0;ctr<RULESIZE;ctr++)
		rules[ctr]=127;
	//ok, here's the rules
	SetRule(rules,0,0,0,0,0,0);
	SetRule(rules,0,0,0,0,1,2);
	SetRule(rules,0,0,0,0,2,0);
	SetRule(rules,0,0,0,0,3,0);
	SetRule(rules,0,0,0,0,5,0);
	SetRule(rules,0,0,0,0,6,3);
	SetRule(rules,0,0,0,0,7,1);
	SetRule(rules,0,0,0,1,1,2);
	SetRule(rules,0,0,0,1,2,2);
	SetRule(rules,0,0,0,1,3,2);
	SetRule(rules,0,0,0,2,1,2);
	SetRule(rules,0,0,0,2,2,0);
	SetRule(rules,0,0,0,2,3,0);
	SetRule(rules,0,0,0,2,6,2);
	SetRule(rules,0,0,0,2,7,2);
	SetRule(rules,0,0,0,3,2,0);
	SetRule(rules,0,0,0,5,2,5);
	SetRule(rules,0,0,0,6,2,2);
	SetRule(rules,0,0,0,7,2,2);
	SetRule(rules,0,0,1,0,2,2);
	SetRule(rules,0,0,1,1,2,0);
	SetRule(rules,0,0,2,0,2,0);
	SetRule(rules,0,0,2,0,3,0);
	SetRule(rules,0,0,2,0,5,0);
	SetRule(rules,0,0,2,1,2,5);
	SetRule(rules,0,0,2,2,2,0);
	SetRule(rules,0,0,2,3,2,2);
	SetRule(rules,0,0,5,2,2,2);
	SetRule(rules,0,1,2,3,2,1);
	SetRule(rules,0,1,2,4,2,1);
	SetRule(rules,0,1,2,5,2,5);
	SetRule(rules,0,1,2,6,2,1);
	SetRule(rules,0,1,2,7,2,1);
	SetRule(rules,0,1,2,7,5,1);
	SetRule(rules,0,1,4,2,2,1);
	SetRule(rules,0,1,4,3,2,1);
	SetRule(rules,0,1,4,4,2,1);
	SetRule(rules,0,1,4,7,2,1);
	SetRule(rules,0,1,6,2,5,1);
	SetRule(rules,0,1,7,2,2,1);
	SetRule(rules,0,1,7,2,5,5);
	SetRule(rules,0,1,7,5,2,1);
	SetRule(rules,0,1,7,6,2,1);
	SetRule(rules,0,1,7,7,2,1);
	SetRule(rules,0,2,5,2,7,1);
	SetRule(rules,1,0,0,0,1,1);
	SetRule(rules,1,0,0,0,6,1);
	SetRule(rules,1,0,0,0,7,7);
	SetRule(rules,1,0,0,1,1,1);
	SetRule(rules,1,0,0,1,2,1);
	SetRule(rules,1,0,0,2,1,1);
	SetRule(rules,1,0,0,2,4,4);
	SetRule(rules,1,0,0,2,7,7);
	SetRule(rules,1,0,0,5,1,1);
	SetRule(rules,1,0,1,0,1,1);
	SetRule(rules,1,0,1,1,1,1);
	SetRule(rules,1,0,1,2,4,4);
	SetRule(rules,1,0,1,2,7,7);
	SetRule(rules,1,0,2,0,2,6);
	SetRule(rules,1,0,2,1,2,1);
	SetRule(rules,1,0,2,2,1,1);
	SetRule(rules,1,0,2,2,4,4);
	SetRule(rules,1,0,2,2,6,3);
	SetRule(rules,1,0,2,2,7,7);
	SetRule(rules,1,0,2,3,2,7);
	SetRule(rules,1,0,2,4,2,4);
	SetRule(rules,1,0,2,6,2,6);
	SetRule(rules,1,0,2,6,4,4);
	SetRule(rules,1,0,2,6,7,7);
	SetRule(rules,1,0,2,7,1,0);
	SetRule(rules,1,0,2,7,2,7);
	SetRule(rules,1,0,5,4,2,7);
	SetRule(rules,1,1,1,1,2,1);
	SetRule(rules,1,1,1,2,2,1);
	SetRule(rules,1,1,1,2,4,4);
	SetRule(rules,1,1,1,2,5,1);
	SetRule(rules,1,1,1,2,6,1);
	SetRule(rules,1,1,1,2,7,7);
	SetRule(rules,1,1,1,5,2,2);
	SetRule(rules,1,1,2,1,2,1);
	SetRule(rules,1,1,2,2,2,1);
	SetRule(rules,1,1,2,2,4,4);
	SetRule(rules,1,1,2,2,5,1);
	SetRule(rules,1,1,2,2,7,7);
	SetRule(rules,1,1,2,3,2,1);
	SetRule(rules,1,1,2,4,2,4);
	SetRule(rules,1,1,2,6,2,1);
	SetRule(rules,1,1,2,7,2,7);
	SetRule(rules,1,1,3,2,2,1);
	SetRule(rules,1,2,2,2,4,4);
	SetRule(rules,1,2,2,2,7,7);
	SetRule(rules,1,2,2,4,3,4);
	SetRule(rules,1,2,2,5,4,7);
	SetRule(rules,1,2,3,2,4,4);
	SetRule(rules,1,2,3,2,7,7);
	SetRule(rules,1,2,4,2,5,5);
	SetRule(rules,1,2,4,2,6,7);
	SetRule(rules,1,2,5,2,7,5);
	SetRule(rules,2,0,0,0,1,2);
	SetRule(rules,2,0,0,0,2,2);
	SetRule(rules,2,0,0,0,4,2);
	SetRule(rules,2,0,0,0,7,1);
	SetRule(rules,2,0,0,1,2,2);
	SetRule(rules,2,0,0,1,5,2);
	SetRule(rules,2,0,0,2,1,2);
	SetRule(rules,2,0,0,2,2,2);
	SetRule(rules,2,0,0,2,3,2);
	SetRule(rules,2,0,0,2,4,2);
	SetRule(rules,2,0,0,2,5,0);
	SetRule(rules,2,0,0,2,6,2);
	SetRule(rules,2,0,0,2,7,2);
	SetRule(rules,2,0,0,3,2,6);
	SetRule(rules,2,0,0,4,2,3);
	SetRule(rules,2,0,0,5,1,7);
	SetRule(rules,2,0,0,5,2,2);
	SetRule(rules,2,0,0,5,7,5);
	SetRule(rules,2,0,0,7,2,2);
	SetRule(rules,2,0,1,0,2,2);
	SetRule(rules,2,0,1,1,2,2);
	SetRule(rules,2,0,1,2,2,2);
	SetRule(rules,2,0,1,4,2,2);
	SetRule(rules,2,0,1,7,2,2);
	SetRule(rules,2,0,2,0,2,2);
	SetRule(rules,2,0,2,0,3,2);
	SetRule(rules,2,0,2,0,5,2);
	SetRule(rules,2,0,2,0,7,3);
	SetRule(rules,2,0,2,1,2,2);
	SetRule(rules,2,0,2,1,5,2);
	SetRule(rules,2,0,2,2,1,2);
	SetRule(rules,2,0,2,2,2,2);
	SetRule(rules,2,0,2,2,7,2);
	SetRule(rules,2,0,2,3,2,1);
	SetRule(rules,2,0,2,4,2,2);
	SetRule(rules,2,0,2,4,5,2);
	SetRule(rules,2,0,2,5,2,0);
	SetRule(rules,2,0,2,5,5,2);
	SetRule(rules,2,0,2,6,2,2);
	SetRule(rules,2,0,2,7,2,2);
	SetRule(rules,2,0,3,1,2,2);
	SetRule(rules,2,0,3,2,1,6);
	SetRule(rules,2,0,3,2,2,6);
	SetRule(rules,2,0,3,4,2,2);
	SetRule(rules,2,0,4,2,2,2);
	SetRule(rules,2,0,5,1,2,2);
	SetRule(rules,2,0,5,2,1,2);
	SetRule(rules,2,0,5,2,2,2);
	SetRule(rules,2,0,5,5,2,1);
	SetRule(rules,2,0,5,7,2,5);
	SetRule(rules,2,0,6,2,2,2);
	SetRule(rules,2,0,6,7,2,2);
	SetRule(rules,2,0,7,1,2,2);
	SetRule(rules,2,0,7,2,2,2);
	SetRule(rules,2,0,7,4,2,2);
	SetRule(rules,2,0,7,7,2,2);
	SetRule(rules,2,1,1,2,2,2);
	SetRule(rules,2,1,1,2,6,1);
	SetRule(rules,2,1,2,2,2,2);
	SetRule(rules,2,1,2,2,6,2);
	SetRule(rules,2,1,2,2,7,2);
	SetRule(rules,2,1,4,2,2,2);
	SetRule(rules,2,1,5,2,2,2);
	SetRule(rules,2,1,6,2,2,2);
	SetRule(rules,2,1,7,2,2,2);
	SetRule(rules,2,2,2,2,7,2);
	SetRule(rules,2,2,2,4,4,2);
	SetRule(rules,2,2,2,4,6,2);
	SetRule(rules,2,2,2,7,6,2);
	SetRule(rules,2,2,2,7,7,2);
	SetRule(rules,3,0,0,0,1,3);
	SetRule(rules,3,0,0,0,2,2);
	SetRule(rules,3,0,0,0,4,1);
	SetRule(rules,3,0,0,0,7,6);
	SetRule(rules,3,0,0,1,2,3);
	SetRule(rules,3,0,0,4,2,1);
	SetRule(rules,3,0,0,6,2,2);
	SetRule(rules,3,0,1,0,2,1);
	SetRule(rules,3,0,1,2,2,0);
	SetRule(rules,3,0,2,5,1,1);
	SetRule(rules,4,0,1,1,2,0);
	SetRule(rules,4,0,1,2,2,0);
	SetRule(rules,4,0,1,2,5,0);
	SetRule(rules,4,0,2,1,2,0);
	SetRule(rules,4,0,2,2,2,1);
	SetRule(rules,4,0,2,3,2,6);
	SetRule(rules,4,0,2,5,2,0);
	SetRule(rules,4,0,3,2,2,1);
	SetRule(rules,5,0,0,0,2,2);
	SetRule(rules,5,0,0,2,1,5);
	SetRule(rules,5,0,0,2,2,5);
	SetRule(rules,5,0,0,2,3,2);
	SetRule(rules,5,0,0,2,7,2);
	SetRule(rules,5,0,0,5,2,0);
	SetRule(rules,5,0,2,0,2,2);
	SetRule(rules,5,0,2,1,2,2);
	SetRule(rules,5,0,2,1,5,2);
	SetRule(rules,5,0,2,2,2,0);
	SetRule(rules,5,0,2,2,4,4);
	SetRule(rules,5,0,2,7,2,2);
	SetRule(rules,5,1,2,1,2,2);
	SetRule(rules,5,1,2,2,2,0);
	SetRule(rules,5,1,2,4,2,2);
	SetRule(rules,5,1,2,7,2,2);
	SetRule(rules,6,0,0,0,1,1);
	SetRule(rules,6,0,0,0,2,1);
	SetRule(rules,6,0,2,1,2,0);
	SetRule(rules,6,1,2,1,2,5);
	SetRule(rules,6,1,2,1,3,1);
	SetRule(rules,6,1,2,2,2,5);
	SetRule(rules,6,0,2,1,2,0);
	SetRule(rules,7,0,0,0,7,7);
	SetRule(rules,7,0,1,1,2,0);
	SetRule(rules,7,0,1,2,2,0);
	SetRule(rules,7,0,1,2,5,0);
	SetRule(rules,7,0,2,1,2,0);
	SetRule(rules,7,0,2,2,2,1);
	SetRule(rules,7,0,2,2,5,1);
	SetRule(rules,7,0,2,3,2,1);
	SetRule(rules,7,0,2,5,2,5);
	SetRule(rules,7,0,2,7,2,0);
	
	//display 1st state
	for (j=0;j<256;j++)
		{
			for (i=0;i<256;i++) 
			{
				switch (gridShow[i][j])
				{
				case 0: //black
					rd=gn=bl=0; break;
				case 1: //white
					rd=gn=bl=255; break;
				case 2: //purple
					{
						rd=150;
						gn=0;
						bl=0; break;
					}
				case 3: //red
					{
						rd=255;
						gn=bl=0; break;
					}
				case 4: //green
					{
						gn=255;
						rd=bl=0; break;
					}
				case 5: //yellow
					{
						gn=bl=255;
						rd=0; break;
					}
				case 6: //orange
					{
						rd=gn=255;
						bl=0; break;
					}
				case 7: //blue
					{
						bl=255;
						rd=gn=0; break;
					}
				}

				dc.SetPixel(i,j,RGB(rd,gn,bl));
			}
		}

	int generation=0;	//keep track of number of iterations
	
	//chug away
	while (!view->bKill)
	{
		generation++;
		
		//compute next values
		for (i=0;i<256;i++)
			for (j=0;j<256;j++) 
			{
				//implement toroidal geometry
				int top=(j>0)?j-1:255;
				int right=(i<255)?i+1:0;
				int bottom=(j<255)?j+1:0;
				int left=(i>0)?i-1:255;

				//lookup value - account for rotations
				int ruleNumber=4096*gridShow[i][j] +
					512*gridShow[i][top] +
					64*gridShow[right][j] +
					8*gridShow[i][bottom] +
					gridShow[left][j];
				int ruleNumber2=4096*gridShow[i][j] +
					gridShow[i][top] +
					512*gridShow[right][j] +
					64*gridShow[i][bottom] +
					8*gridShow[left][j];
				//ruleNumber=newRuleNumber<ruleNumber?newRuleNumber:ruleNumber;
				int ruleNumber3=4096*gridShow[i][j] +
					8*gridShow[i][top] +
					gridShow[right][j] +
					512*gridShow[i][bottom] +
					64*gridShow[left][j];
				//ruleNumber=newRuleNumber<ruleNumber?newRuleNumber:ruleNumber;
				int ruleNumber4=4096*gridShow[i][j] +
					64*gridShow[i][top] +
					8*gridShow[right][j] +
					gridShow[i][bottom] +
					512*gridShow[left][j];
				//ruleNumber=newRuleNumber<ruleNumber?newRuleNumber:ruleNumber;

				int tryRule=rules[ruleNumber];
				if (tryRule!=127)
					gridComp[i][j]=tryRule;
				tryRule=rules[ruleNumber2];
				if (tryRule!=127)
					gridComp[i][j]=tryRule;
				tryRule=rules[ruleNumber3];
				if (tryRule!=127)
					gridComp[i][j]=tryRule;
				tryRule=rules[ruleNumber4];
				if (tryRule!=127)
					gridComp[i][j]=tryRule;
			}

		//update the array & display it
		for (i=0;i<256;i++)
		{
			for (j=0;j<256;j++) 
			{
				if ((gridShow[i][j]!=gridComp[i][j]) || (generation<10))
														//need to black out window
				{
					switch (gridComp[i][j])
				{
				case 0: //black
					rd=gn=bl=0; break;
				case 1: //white
					rd=gn=bl=255; break;
				case 2: //purple
					{
						rd=150;
						gn=0;
						bl=0; break;
					}
				case 3: //red
					{
						rd=255;
						gn=bl=0; break;
					}
				case 4: //green
					{
						gn=255;
						rd=bl=0; break;
					}
				case 5: //yellow
					{
						gn=bl=255;
						rd=0; break;
					}
				case 6: //orange
					{
						rd=gn=255;
						bl=0; break;
					}
				case 7: //blue
					{
						bl=255;
						rd=gn=0; break;
					}
				} //switch

					dc.SetPixel(i,j,RGB(rd,gn,bl));
				}  //if
				gridShow[i][j]=gridComp[i][j];
			}
		}
	} 
	return 0;
}


void CCatryView::OnInitialUpdate() 
{
	bKill=FALSE;
	pThread=AfxBeginThread(DotThread,this);
	pThread->m_bAutoDelete=FALSE;
	CView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	
}

void CCatryView::OnDestroy() 
{
	bKill=TRUE;
	WaitForSingleObject(pThread->m_hThread,INFINITE);
	delete pThread;

	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	
}


